# coding: utf-8
# Copyright 2023 OpenSPG Authors
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
# in compliance with the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed under the License
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
# or implied.


"""
    knext

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from knext.common.rest.configuration import Configuration


class MultiVersionConfig(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {"pattern": "str", "max_version": "int", "ttl": "int"}

    attribute_map = {"pattern": "pattern", "max_version": "maxVersion", "ttl": "ttl"}

    def __init__(
        self, pattern=None, max_version=None, ttl=None, local_vars_configuration=None
    ):  # noqa: E501
        """MultiVersionConfig - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._pattern = None
        self._max_version = None
        self._ttl = None
        self.discriminator = None

        if pattern is not None:
            self.pattern = pattern
        if max_version is not None:
            self.max_version = max_version
        if ttl is not None:
            self.ttl = ttl

    @property
    def pattern(self):
        """Gets the pattern of this MultiVersionConfig.  # noqa: E501


        :return: The pattern of this MultiVersionConfig.  # noqa: E501
        :rtype: str
        """
        return self._pattern

    @pattern.setter
    def pattern(self, pattern):
        """Sets the pattern of this MultiVersionConfig.


        :param pattern: The pattern of this MultiVersionConfig.  # noqa: E501
        :type: str
        """

        self._pattern = pattern

    @property
    def max_version(self):
        """Gets the max_version of this MultiVersionConfig.  # noqa: E501


        :return: The max_version of this MultiVersionConfig.  # noqa: E501
        :rtype: int
        """
        return self._max_version

    @max_version.setter
    def max_version(self, max_version):
        """Sets the max_version of this MultiVersionConfig.


        :param max_version: The max_version of this MultiVersionConfig.  # noqa: E501
        :type: int
        """

        self._max_version = max_version

    @property
    def ttl(self):
        """Gets the ttl of this MultiVersionConfig.  # noqa: E501


        :return: The ttl of this MultiVersionConfig.  # noqa: E501
        :rtype: int
        """
        return self._ttl

    @ttl.setter
    def ttl(self, ttl):
        """Sets the ttl of this MultiVersionConfig.


        :param ttl: The ttl of this MultiVersionConfig.  # noqa: E501
        :type: int
        """

        self._ttl = ttl

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict())
                        if hasattr(item[1], "to_dict")
                        else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MultiVersionConfig):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MultiVersionConfig):
            return True

        return self.to_dict() != other.to_dict()
